#!/usr/bin/perl -w

# Input an asm height function
# as space delimited numbers.
# determines size from line breaks
# outputs grid of 0/1 for temperate/frozen
# or 0/1/-1 if given the -sign flag
# this dfn of frozen lies on the asm grid, not the height grid


$signed=0;
if ( $#ARGV > -1 && $ARGV[0] =~ /^-s/ ) {
  shift @ARGV;
  $signed=1;
  }

while( <> ) {
  s/^\s*//;
  @{$L[$#L+1]}=split(/\s+/,$_);
  }
#print"$L[0][0]\n";
#for( @L ) { for( @{$_} ) { print;print" "; } print"\n"; }

$size=$#L+1;

for$i(0..$#L-1){ # frozen region lies on asm grid, smaller than height grid
  for$j(0..$#L-1) {
    if( &maxarctic($i,$j) && &maxarctic($i+1,$j) &&
        &maxarctic($i,$j+1) && &maxarctic($i+1,$j+1) ) {
      print "  1";
      }
    elsif( &minarctic($i,$j) && &minarctic($i+1,$j) &&
        &minarctic($i,$j+1) && &minarctic($i+1,$j+1) ) {
      print $signed ? " -1" : "  1";
      }
    else { print "  0"; }
    }
    print"\n";		#
 }

exit(0);	#


sub maxarctic {
  my($i,$j)=@_;
  return ($L[$i][$j]==$size-abs($size-$i-$j-1));
  }
sub minarctic {
  my($i,$j)=@_;
  return ($L[$i][$j]==abs($i-$j)+1);
  }
#sub arctic {
#  my($i,$j)=@_;
#  my($tmpa,$tmpb);
#  $tmpa = ($L[$i][$j]==$size-abs($size-$i-$j-1));
#  $tmpb = ($L[$i][$j]==abs($i-$j)+1);
#  return -1 if $tmpb;
#  return 1 if $tmpa;
#  return 0;
#  }

