#!/usr/bin/perl -w

# inputs matrix
# numbers separated by spaces (will output different spaces)
# rows terminated by line breaks
# places into 6 buckets: min, min-10%, 10-50%, 50-90%, 90-100, 100

while( <> ) {
  s/^\s*//;
  @{$L[$#L+1]}=split(/\s+/,$_);
  }

$max=$min=$L[0][0];

for(@L) {
  for(@{$_}) {
    $max = $_ if $_ > $max;
    $min = $_ if $_ < $min;
    }
  }
$range = $max - $min;
$b1 = $min + $range/10;
$b2 = $min + $range/2;
$b3 = $max - $range/10;

for $line (@L) {
  for $item (@{$line}) {
    print &bucket($item), " "; 
    }
  print"\n";
  }

sub bucket {
  my($item)=@_;
  return 0 if( $item == $min );
  #return 5 if( $item == $min ); # save ink
  return 5 if( $item == $max );
  return 1 if( $item < $b1 ); #symmetric: 10%, 90% buckets exclude endpoints
  return 4 if( $item > $b3 );
  return 2 if( $item < $b2 );
  return 3; # asymmetric - middle goes to higher bucket
  #print STDERR "$item not in range\n";
  #return 4;
  }
